﻿# -*- coding:Utf-8 -*-
# ./addons/eventscripts/unscope_mod/unscope_mod.py

'''
	=================================[ Code par Messiah ]=================================
	* Nom du script : Unscope Mod                                                        *
	* Version       : V1.0                                                               *
	* Auteur        : Messiah93                                                          *
	* Page internet : http://addons.eventscripts.com/addons/view/Unscope_Mod             *
	* Licence       : (Aucune pour ce script)                                            *
	=================================[ Code par Messiah ]=================================
'''

import es, popuplib, gamethread, keyvalues, ConfigParser, playerlib

info = es.AddonInfo()
info.name = "[FR] Unscope Mod"
info.version = "v1.0"
info.author = "Messiah93"
info.url = "http://addons.eventscripts.com/addons/view/Unscope_Mod"

##############################
fichierDeConfiguration = ConfigParser.ConfigParser()
FichierDeConfiguration2 = ConfigParser.ConfigParser()
fichierDeConfiguration.read ("%s/addons/eventscripts/unscope_mod/unscope_mod_config.ini" % es.server_var['eventscripts_gamedir'])
unscope_Mod_Texte		     = fichierDeConfiguration.get("Principal", "Text")
unscope_Mod_Sound		     = fichierDeConfiguration.get("Principal", "Sound")
##############################

def load ():
	es.ServerVar("Messiah_UnscopeMod", info['version']).makepublic()
	global unscopemod_mode
	unscopemod_mode = "OFF"
	buildPopup()
	es.regclientcmd ("unscope_mod", "unscope_mod/regClientCommand")
	es.msg ("#multi", "[#greenUnscope Mod#default] Script #lightgreenChargé avec succès#default !")
	es.log ("[Unscope-Mod] : Script charge avec succes !")

def unload ():
	es.unregclientcmd ("unscope_mod")
	es.msg ("#multi", "[#greenUnscope Mod#default] Script #lightgreenDéchargé avec succès#default !")
	es.log ("[Unscope-Mod] : Script decharge avec succes !")

def buildPopup ():
	menu = popuplib.create("unscopemod_popup")
	menu.addline("- Unscope Mod -")
	menu.addline("------------------")
	menu.addline("->1. Activer")
	menu.addline("->2. Désactiver")
	menu.addline("->3. Lancer un vote")
	menu.addline("------------------")
	menu.addline("->0. Fermer")
	menu.menuselect = menuSelectOptions

def menuSelectOptions (userid, choix, popup):
	global unscopemod_mode
	if choix == 1:
		if unscopemod_mode != "ON":
			unscopemod_mode = "ON"
			es.msg ("#multi", "[#greenUnscope Mod#default] Unscope :#lightgreen ON !")
			gamethread.delayed(1, es.centermsg, ("! Mod Unscope Activé !"))
			gamethread.delayed(2, es.centermsg, ("!! Mod Unscope Activé !!"))
			gamethread.delayed(3, es.centermsg, ("!!! Mod Unscope Activé !!!"))
			for _Player in es.getUseridList():
				es.setplayerprop (_Player, "CBasePlayer.m_iFOV", 0)
		else:
			es.tell (userid, "#multi", "#default[#greenUnscope Mod#default] Mode unscope déjà#lightgreen ON !")
		popuplib.send("unscopemod_popup", userid)
		es.cexec (userid, "playgamesound UI/buttonrollover.wav")
	if choix == 2:
		if unscopemod_mode != "OFF":
			unscopemod_mode = "OFF"
			es.msg ("#multi", "[#greenUnscope Mod#default] Unscope :#lightgreen OFF !")
			gamethread.delayed(1, es.centermsg, ("! Mod Unscope Désactivé !"))
			gamethread.delayed(2, es.centermsg, ("!! Mod Unscope Désactivé !!"))
			gamethread.delayed(3, es.centermsg, ("!!! Mod Unscope Désactivé !!!"))
		else:
			es.tell (userid, "#multi", "#default[#greenUnscope Mod#default] Mode unscope déjà#lightgreen OFF !")
		popuplib.send("unscopemod_popup", userid)
		es.cexec (userid, "playgamesound UI/buttonrollover.wav")
	if choix == 3:
		if unscopemod_mode == "OFF":
			es.server.queuecmd ("ma_votequestion \"Lancer le mode Unscope ?\" \"Oui\" \"Non\"")
		else:
			es.server.queuecmd ("ma_votequestion \"Enlever le mode Unscope ?\" \"Oui\" \"Non\"")
		es.cexec (userid, "playgamesound UI/buttonrollover.wav")

def regClientCommand ():
	userid = es.getcmduserid()
	steamid = es.getplayersteamid(userid)
	if steamid in getAdminList():
		popuplib.send("unscopemod_popup", userid)
	else:
		es.tell (userid, "#multi", "[#greenUnscope Mod#default] #lightgreenTu n'es pas admin !")

def getAdminList():
	adminlist = []
	adminGrouplist = set()
	admins = keyvalues.KeyValues(name = "messiah_mani_admins")
	admins.load("%s/cfg/mani_admin_plugin/clients.txt" % es.server_var["eventscripts_gamedir"])
	try:  
		for group in admins["groups"]["Admin"]:
			groupName = group.getName()
			if "admin" in group.getString():
				adminGrouplist.add(groupName)
	except KeyError:
		pass
	for admin in admins["players"]:
		try:
			for group in admin["groups"]:
				groupValue = group.getString()
				if groupValue in adminGrouplist or "admin" in groupValue:
					adminlist.append(admin.getString("steam"))
		except KeyError:
			pass
		try:  
			for group in admin["flags"]:
				groupValue = group.getString()
				if groupValue in adminGrouplist or "admin" in groupValue:
					adminlist.append(admin.getString("steam"))
		except KeyError:
			pass
	return adminlist

def weapon_zoom (event_var):
	if unscopemod_mode == "ON":
		es.server.cmd ("est_fade %s 0 0.15 0.15 1 1 1 255" % event_var['userid'])
		es.centertell (event_var['userid'], unscope_Mod_Texte)
		es.cexec (event_var['userid'], "playgamesound %s" % unscope_Mod_Sound)
		es.setplayerprop (event_var['userid'], "CBasePlayer.m_iFOV", 0)

def es_map_start (event_var):
	global unscopemod_mode
	FichierDeConfiguration2.read("%s/addons/eventscripts/unscope_mod/ListMaps.ini" % es.server_var['eventscripts_gamedir'])
	MapSection = FichierDeConfiguration2.has_section(event_var['mapname'])
	if MapSection == True: # La map est bien dans le fichier de configuration
		MapOption = FichierDeConfiguration2.has_option(event_var['mapname'], "Unscope")
		if MapOption == True: # L'option Unscope est bien
			UnscopeMod = FichierDeConfiguration2.getint(event_var['mapname'], "Unscope")
			if UnscopeMod == 1: # Le mode unscope est activé pour cette map
				unscopemod_mode = "ON"
			else: # Le mode unscope est désactivé pour cette map
				unscopemod_mode = "OFF"
		else: # L'option Unscope est absente (Probleme d'utilisation de l'utilisateur ?)
			unscopemod_mode = "OFF"
	else: # Le map n'est pas dans le fichier de configuration
		unscopemod_mode = "OFF"